/////Bitter Creek Skirmish.wdl, Feb. 2006, v.1.2 //////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
path "d:\\gamestudio\\template";	// Path to WDL templates subdirectory
path "d:\\gamestudio\\Battle";
////////////////////////////////////////////////////////////////////////////
include <movement.wdl>;
include <Outpost_messages.wdl>;
include <menu.wdl>;		// must be inserted before doors and weapons
include <Outpost_particle.wdl>; // remove when you need no particles
include <doors.wdl>;		// remove when you need no doors
include <actors.wdl>;   // remove when you need no actors
include <outpost_weapons2.wdl>;  // remove when you need no weapons
include <outpost_war.wdl>;      // remove when you need no fighting
include <lflare.wdl>;   // remove when you need no lens flares
include <exdemo.wdl>;   //Thanks to Snake67
include <Outpost_camera.wdl>;
include <NiverAI.wdl>;    //Thanks to Claus Nielsen

var enemy_pos[30] = -255,0,10,  -130,-270,10, 0,-100,10, -200,260,10, -140,290,10, -270,-340,10, -250,-200,0, 275,380,10 -222,400,10, 0,0,10;//
var ammopan = 0;
var hbar = 0;
var renewal = 0;
var x;
var z;
var index = 0;
var half_minute = 0;
var end_it = 0;
bind <dparticle.mdl>;
bind <indian.mid>;
bind <theme.wav>;
bind <ricochets.wav>;
bind <bugle.wav>;
level "outpost.wmp";
////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
var video_mode = 7;	 // 
var video_depth = 16; // 16 bit colour D3D mode
var video_screen = 1;
FONT outpost2_font,"ariel",1,22; 
/////////////////////////////////////////////////////////////////
string level_str = <Outpost.WMB>; // give file names in angular brackets
sound chip_click_wav = <klick.wav>;
sound gunjam_wav = <gunjam.wav>;
sound warpath = <warpath.wav>; 


/////////////////////////////////////////////////////////////////
// define a splash screen with the required A4/A5 logo
bmap logolite = <logolite.pcx>; // the default logo in templates
panel splashscreen {
	pos_x = 0;
	pos_y = 0;
	bmap = logolite;
	flags = refresh,d3d;
}
BMAP outpost_title = <battle_title.pcx>;
panel titlescreen
{
	pos_x = 0;
	pos_y = 0;
	bmap = outpost_title;
	flags = refresh, d3d;
}

BMAP outpost_splash = <battle_splash.pcx>;
bmap play_but_pcx = <play.pcx>;
bmap play_but2_pcx = <play2.pcx>;
bmap help_but_pcx = <help.pcx>;
bmap help_but2_pcx = <help2.pcx>;
bmap quit_but = <quit_but.pcx>;
bmap quit_but2 = <quit_but2.pcx>;

panel splashscreen2
{
	bmap = outpost_splash;
	button = 250,510,help_but_pcx,help_but_pcx,help_but2_pcx,null,see_help_off,see_help;
	button = 370,510,play_but_pcx,play_but_pcx,play_but2_pcx,start_game,null,null;	
	button = 490,510,quit_but,quit_but,quit_but2,game_exit,null,null;
	layer = 1;
	flags = refresh,d3d;
}

bmap medal_scroll = <medal_scroll.pcx>;
panel success
{
	bmap = medal_scroll;
	pos_x = 200;
	pos_y = 70;
	flags = d3d,refresh,overlay;
}

////////////////////////////////////////////////////////////////////////////
// The following script controls the sky
sky horizon_sky 
{
	type = <horizon4.tga>;
	tilt = -10;
	flags = scene,overlay,visible,transparent;
	layer = 3;
	scale_x = 0.18; 
	
}  

/////////////////////////////////////////////////////////////////
function main()
{
	on_mouse_right = null;
	tex_share = on;	// map entities share their textures
	splashscreen.visible = on;
   
	sleep(4);
	splashscreen.visible = off;
	 bmap_purge(logolite);
	 wait(3);
	 titlescreen.visible = on;
	 media_play("theme.wav",null,100);
   sleep(6);
   titlescreen.visible = off;
   bmap_purge(outpost_title);
   wait(3);
   
   mouse_mode = 1;
   mouse_on();
   
   splashscreen2.VISIBLE = ON;
   // wait 3 frames (for triple buffering) until it is flipped to the foreground
   wait(3);
	freeze_mode = 1;

	fog_color = 4;
	camera.fog_start = 300; //0.5 * clip_range; // fog at 80% of clip_range
	camera.fog_end = 2000;
//	camera.fog_start = 0.5 * clip_range; // fog at 80% of clip_range
//	camera.fog_end = 0.9 * clip_range; 
//	clip_range = 5000; 
	
	move_view_cap = 0;
	Health_panel();
	
	on_f1 = null;
	on_f7 = null;
	on_f10 = null;
	on_f12 = null;
	on_f6 = null;
	on_f5 = null;
	
}

function main2()
{
	mouse_mode = 1;
   mouse_on();
	splashscreen2.VISIBLE = ON;
   wait(3);
	freeze_mode = 1;

	fog_color = 4;
	camera.fog_start = 0.5 * clip_range; // fog at 80% of clip_range
	camera.fog_end = 0.9 * clip_range; 
	clip_range = 5000; 
	
	move_view_cap = 0;
	Health_panel();
	
	on_f1 = null;
	on_f7 = null;
	on_f10 = null;
	on_f12 = null;
	on_f6 = null;
	on_f5 = null;
	on_mouse_right = null;
	
}

function start_game()
{


	my = null;
	ammo3 = 450;
	renewal = 0;
	hbar = 0;
	index = 0;
	snd_play(chip_click_wav,100,0);
	splashscreen2.VISIBLE = Off;
	bmap_purge(OUTPOST_SPLASH);
	mouse_mode = 0;
	level_load(level_str);
	wait(2);
	garrison_dead();
	sleep(5);
	media_play("bugle.wav",null,100);
	freeze_mode = 0;
	fps_max = 40;
	pan_cross_show();
	sleep(2.4);
//	ricochets();
	sleep(6);
	play_sound,warpath,50;
	sleep(6);
	media_loop ("indian.mid", null, 500);
	x = media_handle;
	player._health = 100;
	player._armor = 100;
	success.visible = off;
}

function pause()
{ 
	if(freeze_mode == 2) // all frozen??
	{
		freeze_mode = 0; // go on
	}
	else
	{
		freeze_mode = 2; // pause		
	}
} 

bmap garrison_info = <battle_small_info.pcx>;
panel garrison
  {
  bmap = garrison_info;
  pos_x = 200;
  pos_y = 50;
  flags = refresh,d3d;
  LAYER 1;
  FLAGS OVERLAY;
  }
  
function garrison_dead
   {
	   freeze_mode = 1;
	   GARRISON.visible = on;
	   sleep(5);
	   GARRISON.visible = off;
	   freeze_mode = 0;
   }
sound chief_yell = <chief_yell.wav>;   
sound galloping = <galloping.wav>;
sound whinny = <whinny.wav>;
string enemy_mdl = <indian3.mdl>;
string horse_mdl = <warpony2.mdl>;
string chief_mdl = <chief.mdl>;
string indian1_mdl = <indian1.mdl>;
string indian2_mdl = <indian2.mdl>;

function generate_enemies() //for outpost
{
	
 while(1)
	{
		
		sleep(7 + random (2)); //was 9
		index = 3 * int(random(10)); // generates a random number between 0 and 27 step 3 (0, 3, 6, 9, 12, ... 27)
		temp.x = enemy_pos[index+0];
		temp.y = enemy_pos[index+1]; 
		temp.z = 10; 
		ent_create(enemy_mdl, temp, indian_rifle_fight); // create an enemy
	}
}

function generate_horses() //for outpost
{
	waitt (412);//512
	while (1)
	{
		waitt (412);//512
		temp.x = -500;
		temp.y = -100;
		temp.z = -10;
  		ent_create(horse_mdl, temp, rider_fight); // create an enemy rider
  		play_sound, galloping, 40;
  		sleep(4);
  		play_sound, warpath, 40;
	}
	if(end_it == 1){return;}
}

function generate_horse2()  //for Outpost
{
waitt(560);//660
	while (1)
	{
		waitt (560);//660
		temp.x = 630;
		temp.y = 630;
		temp.z = 8;
		ent_create(horse_mdl, temp, rider_fight); // create an enemy rider
  		PLAY_SOUND, whinny, 40;
	   play_sound, galloping, 40;
	}
	if(end_it == 1){return;}
}

function generate_leader() 
{
	
	half_minute = 12;	       //workaround for delay of more than 60 seconds//12
	while(half_minute > 0)
	{
		sleep(22);//29
		half_minute -= 1;
	}	
		play_sound, chief_yell,30;
		sleep(4);		
		temp.x = -500;
		temp.y = -200;
		temp.z = 0;
		ent_create(horse_mdl, temp,black_rider_fight); 
	   PLAY_SOUND, whinny, 50;
	   play_sound, galloping, 40;
	   wait(1);
   
}


function generate_horse4() //DOUBLES UP
{
waitt(624);//1024
	while (1)
	{
		waitt(624);//1024
		temp.x = -500;
		temp.y = -200;
		temp.z = 8;
		ent_create(horse_mdl, temp,blue_rider_fight); // create an enemy rider
  		play_sound, galloping, 40;
	}
	if(end_it == 1){return;}
}

function generate_enemy2() 
{
	waitt (300);//400
	while (1)
	{
		waitt (300);//400
		temp.x = -220;
		temp.y = 100;
		temp.z = 8;
  		ent_create(chief_mdl, temp,indian_rifle_fight);  
 	}
 	if(end_it == 1){return;}
}

 function generate_enemy3() 
{
	waitt (500);//800
	while (1)
	{
		waitt (500);//800
		temp.x = 121;
		temp.y = -700;
		temp.z = 0;
  		ent_create(indian1_mdl, temp, indian_rifle_fight);
 	}
 	if(end_it == 1){return;}
}

function generate_enemy4() 
{
	waitt (400);//700
	while (1)
	{
		waitt (400);//700
		temp.x =-65;
		temp.y = 385;
		temp.z = 0;
  		ent_create(indian2_mdl, temp, indian_rifle_fight);
 	}
 	if(end_it == 1){return;}
}


function ricochets()
{	
	media_loop("ricochets.wav",null,60);
	z = media_handle;
}

action spawner
{
	generate_enemies();
	generate_enemy3();
	generate_enemy2();
	generate_enemy4();
	generate_leader();
	generate_horses();
	generate_horse2();
	generate_horse4();
	ricochets();	
}

var player_strength[3];

FUNCTION stop_me
{
	vec_set (player_strength, strength); // store player's speed on x, y, z
   vec_set (strength, nullvector); // stop the player
   wait(1);
}

function start_me // call it in main
   {
        vec_set (strength, player_strength);
        WAIT(1);
    }
    
bmap health_map = <health+9.pcx>;    
panel hbar_pan
  {
  hbar 50,0,50 health_map,.5,player._health; //changed from 50 0 50
  pos_x=38;
  layer = 1;
  FLAGS OVERLAY,d3d,refresh;  
  }
  
bmap panel1 = <pan1pic2.bmp>;
Panel square_Pan
  {
  BMAP panel1;
  POS_X=10;
  LAYER 1;
  FLAGS OVERLAY,d3d,refresh;  
  }
  
FONT outpost_font,"Times",1,22; 

panel digpan1
  {
  pos_x   25;
  digits  0,0,3,outpost_font,1,ammopan;
  FLAGS OVERLAY,d3d,refresh;  
  }
    
 function health_panel()
  {
  digpan1.visible = ON;
  hbar_pan.VISIBLE = ON;
  square_Pan.VISIBLE=ON;
  while(1)
    {
    digpan1.pos_y = screen_size.y -40;
    square_Pan.POS_Y=SCREEN_SIZE.Y - 52;
    hbar_pan.POS_Y = SCREEN_SIZE.Y - 33;
    if(ammo_number == 0) 
      {
      ammopan = 0; 
      }
    if(ammo_number == 1) 
      {
      ammopan = ammo1; 
      }
    if(ammo_number == 2) 
      {
      ammopan = ammo2; 
      }
    if(ammo_number == 3) 
      {
      ammopan = ammo3; 
      }
    if(ammo_number == 4) 
      {
      ammopan = ammo4; 
      }
    if (PLAYER !=0)
      {
      hbar = player._HEALTH;
      }
    wait(1);
    }
  }
}



function game_exit()
{	
	exit;
}



bmap black_map <blackpage.pcx>; 
panel black_pan {
	pos_x = 0;
	pos_y = 0;
	layer = 10;
	bmap = black_map;
	flags = overlay,d3d,refresh;
	layer = 13;
}

function fadeout()
{
	splashscreen2.visible = off;
	black_pan.visible = on;
	black_pan.alpha = 100;
	while(black_pan.alpha > 1)
	{
		black_pan.alpha -= 3*time;
		wait(1);
	}
	black_pan.visible = off;
}

bmap outpost_help = <help_outpost.pcx>;
panel showhelp
{
	bmap = outpost_help;
	pos_x = 250;
	pos_y = 70;
	flags = d3d,refresh,overlay;
	layer = 2;
}

function see_help()
{
	snd_play(chip_click_wav,100,0);
	showhelp.visible = on;
}

function see_help_off()
{
	snd_play(chip_click_wav,100,0);
	showhelp.visible = off;
}

string exit_str = "EXIT IN 10 SECONDS";

text exit_warn 
{
  pos_x = 310;
  pos_y = 300;
  font = outpost2_font;
  flags = outline;
  string = exit_str;
}



BMAP restart = <restart.pcx>;
bmap restart2 = <restart2.pcx>;
bmap dead_panel= <dead_scroll.pcx>;
panel expired
  {
  bmap = dead_panel;
  pos_x = 200;
  pos_y = 80;
  button = 165,115,restart,restart,restart2,start_over,null,null;
  flags = refresh,d3d;
  LAYER 2;
  FLAGS OVERLAY;
  }

/////////////////////////////////////
// Code fragment for WDL Script "smoke"
// Created from
//  von  J. Rappo, Frigen   //
//  24. Oktober 2001    //
///////////////

BMAP rauch_map,<smoke.tga>;
var parray [1801]; 
var ppoint = 0;    
var boom = 0; 

function sarray() 
{
   ppoint = 0;
   while (parray [ppoint*6] != 0) 
   {
     ppoint += 1; 
   }
}
   

function smoke_particle()
{
   if(my_age == 0) 
   {
     my_alpha = 0;      // set to invisible at start
     my_color.blue = parray[my_pos.x * 6 + 2];  // get size from array
     my_pos.x = parray[my_pos.x * 6 + 1];   // restore real pos.x
     my_speed.z = (0.7+random(1)) * my_color.blue;  // set speed.z
     my_color.red = random (80);    // set random values
     my_color.green = random (80);
     my_size = (1100+random(200)) * my_color.blue;  // set size
     my_map = rauch_map;
//     my_flare = on;      // set transparency
return;
   }
   if (my_age > 80) 
   {
     // kill if too old
     MY_ACTION = NULL;
   }
   if (my_age > 17) 
   {
     // set alpha according to age
     my_alpha = 40 - my_age/2;
   }
   else 
   {
     my_alpha = my_age * 2; 
   }
   my_speed.x = (sin(my_age * 6 + my_color.red) / 2.5) * my_color.blue; // movement
}

action smoke_bomb
{
   MY.PASSABLE = ON;
   sarray();        // look for free array slot
   if (ppoint >= 300) 
   {
return; 
   }
   // stop action if too many emitters already present
   my.skill14 = ppoint;      // set skill14 accordingly
   parray[my.skill14 * 6] = 1;     // set flag of the slot to occupied
   if (my.skill8 == 0) 
   {
     my.skill8 = 4; 
   }
   // rate 0 defaults to 4
   if (my.skill7 == 0) 
   {
     my.skill7 = 1; 
   }
   // size 0 defaults to 1
   if (my.skill7 < 0.2 && my.skill7 != -1) 
   {
     my.skill7 = 0.2; 
   }
   // check size values and correct them
   if (my.skill7 > 3) 
   {
     my.skill7 = 3; 
   }
   while(1) 
   {
     // smokes forever
     if (my.skill7 > 0) 
     {
       // check if effect is turned ON
       my.skill13 -= 1;    // decrease emit counter
       if (my.skill13 <= 0) 
       {
         my.skill13 = my.skill8 / TIME;     // set counter according to skill8
         parray[my.skill14 * 6 +2] = my.skill7;    // set size value in array
         parray[my.skill14 * 6 +1] = my.x + (random(4) - 2) * my.skill7; // set pos.x value in array
         my.skill10 = my.skill14;     // array pointer stored in x_pos
         my.skill11 = my.y + (random(4) - 2) * my.skill7;  // set pos.y for emit
         my.skill12 = my.z;      // set pos.z for emit
         emit(1,my.skill10,smoke_particle);    // emit particle
       }
     }
     wait(1);
   }
}

string jam_str, "Your Gatling Gun Has Overheated and Jammed....";

text mg_jam
{
	pos_x = 220;
  pos_y = 200;
  font = outpost2_font;

  flags = outline;
  string = jam_str;
} 

string fix_health_str = "HIT THE SPACEBAR TO RENEW HEALTH";

text fix_health
{
	pos_x = 250;
  pos_y = 100;
  font = outpost2_font;
  flags = outline;
  string = fix_health_str;
} 
string warning_str = "STAY ALERT! YOU ARE ABOUT TO DIE!";
text warning
{
	pos_x = 240;
  pos_y = 50;
  font = outpost2_font;
  red = 255;
  green = 80;
  blue = 0;
  flags = outline;
  string = warning_str;
} 

 
function see_health()
{
	if(my._health <= 50)&&(renewal == 0)
	{
		fix_health.visible = on;
		sleep(4);
		fix_health.visible = off;
		
		renewal = 1;
	}
	if(my._health <= 20)&&(renewal == 1)
		{		
			warning.visible = on;
			
		}
	else
		{
			warning.visible = off;
		}
		
}


 function over_heat()
{
	wait(1);
	snd_play(gunjam_wav,50,0);
}
 
function gun_jam
{
	sleep(30);
			sleep(30);
			sleep(30);
			sleep(30);
			sleep(30);
			sleep(30);
			mg_jam.visible = on;
	on_mouse_left = over_heat;
	sleep(8);
	mg_jam.visible = off;
	on_mouse_left = weapon_fire;
			sleep(30);
			sleep(30);
			sleep(30);
			sleep(30);
			sleep(30);
			sleep(30);
			sleep(30);
	mg_jam.visible = on;
	on_mouse_left = null;
	sleep(8);
	mg_jam.visible = off;
	on_mouse_left = weapon_fire;	
}

function game_won()
{
	media_stop(z);
	media_stop(x); // pause the stream with x
	wait(1);
	warning.visible = off;
	pan_cross_hide();
	wait(2);
	media_play("theme.wav",null,100);
//	sleep(3);
	success.visible = on; 
	freeze_mode = 1;	
}


  function start_over()
{
	media_stop(z);
	end_it = 1;
	expired.visible = off;
	exit_warn.visible = off;
	main2();
	
	
}

function get_shot()
    {
    	warning.visible = off;
    	success.visible = off; 
    	wait(2);
		mouse_mode = 1;
		mouse_on();
		media_stop(x); // pause the stream with x
	    expired.visible = on;
	    exit_warn.visible = on;
	    sleep(10);
	    expired.visible = off; 
	    exit_warn.visible = off;
	    game_exit();  
    
    }
    
  


on_esc = game_exit;
on_p = pause();
