/////////////////////////////////////////////////////////// 
// Niver AI v1.2 Alpha - (c) 2005 by Claus Nielsen *** Attack modified for Saharan Outpost by Rod Fisher
// 
// A how-to-use article can be found at www.nighthawk.dk 
// in the c-script section. 
// ----------------------------------------------------- // 
// If you use this in a commercial project, please add me 
// to your credits list. 
// 
// Requires the following files: 
// -explosin.wav 
// -rocket.mdl 
// -dparticle.mdl 
// -expl+16.pcx 
/////////////////////////////////////////////////////////// 
// Defines 
define speed_x,skill1; 
define speed_y,skill2; 
define speed_z,skill3; 
define range,skill4; 
define scan_circle_pan,skill5; 
define scan_circle_tilt,skill6; 
define scan_circle_lenght,skill7; 
define fire_mode,skill8; 
define health,skill9; 
define damage,skill10; 
define team,skill11; 
define target_x,skill12; 
define target_y,skill13; 
define target_z,skill14; 
define jump_dist,skill15; 
define jump_pause,skill16; 
define enemy,skill17; 
define scan_mode,skill18; 
define AI_tilt,skill19; 
define fire_normal,0; 
define fire_dparticle,1; 
define fire_rapid,2; 
define fire_slow,4; 
define fire_rocket,8; 
define fire_scatter,16; 
define weap_macgun,3; 
define weap_launcher,12; 
define weap_shotgun,21; 
define rocket_speed,25; 
define dparticle_speed,60; 
define scan_explo,1; 
define scan_bullet,2; 
define scan_Search,3; 
/////////////////////////////////////////////////////////// 
// Strings 
string walk_anim = "walk"; 
string run_anim = "run"; 
string stand_anim = "idle"; 
string alt_stand_anim = "stand"; 
string attack_anim = "attack"; 
string death_anim = "death"; 
string rocket_mdl = "rocket.mdl"; 
string dparticle_mdl = "dparticle.mdl"; 
string explosion = "expl+16.pcx"; 
/////////////////////////////////////////////////////////// 
// Sounds 
//sound explo_snd = "explosin.wav"; 
/////////////////////////////////////////////////////////// 
function NiverAI_event() 
{ 
   
   if(event_type == event_scan) 
   { 
      if(you) 
      { 
         if(you.scan_mode == scan_Search && my.team != you.team) 
         { 
            you.enemy = handle(my); 
         } 
          
         if(you.scan_mode == scan_explo) 
         { 
            my.health -= (you.damage / vec_dist(my.x,you.x)) * 100; 
            if(you.parent != 0){my.enemy = you.parent;} 
         } 
      } 
   } 
   if(event_type == event_impact) 
   { 
      if(you) 
      { 
         if(you.scan_mode == scan_bullet) 
         { 
            if(you.parent != 0){my.enemy = you.parent;} 
         } 
      } 
   } 
   if(event_type == event_detect) 
   { 
      if(you) 
      { 
         if(you.team != my.team) {my.enemy = handle(you);} 
      } 
   } 
} 

function Niver_hityou() 
{ 
   if(you) {you.health -= my.damage;} 
   wait(1); 
   remove me; 
} 
function Niver_dparticle() 
{ 
   if(you == null){remove me;return;} 
   vec_scale(my.scale_x,0.5); 
   my.enable_entity = on; 
   my.enable_block = on; 
   my.event = Niver_hityou; 
   my.enemy = you.enemy; 
   my.damage = you.damage; 
   my.pan = you.pan; 
   my.tilt = you.AI_tilt; 
   //you = ptr_for_handle(my.enemy); 
   my.narrow = on; 
   while(my) 
   { 
      c_move(my,vector(dparticle_speed*time,0,0),nullvector,ignore_passable+glide+ignore_you); 
      wait(1); 
   } 
   if(my) {remove me;} 
} 
/////////////////////////////////////////////////////////// 
function NiverAI_attack() 
{ 
   var dparticle; 
   var fire_pause = 8; 

   temp.x = my.x + fcos(my.pan,60); 
   temp.y = my.y + fsin(my.pan,60); 
   temp.z = my.z; 
   ent_create(dparticle_mdl,temp,Niver_dparticle); 
      
   fire: 
   
   my.fire_mode = fire_dparticle;
   sleep(1.6);
   ent_playsound(me,rifle_shot,100);
   wait(2);
   vec_for_vertex(temp,me,564); 
	emit(temp,temp.x,rifle_smoke);
	CREATE <myflash79.pcx>,temp,enemy_flash;
	
	return(fire_pause); 
} 
/////////////////////////////////////////////////////////// 
function Niver_AI() 
{ my.skill11=0;
	my.fire_mode = 0;
   my.narrow = on; 
   if(my.health == 0) {my.health = 1000;} 
   if(my.range == 0) {my.range = 1000;} 
   if(my.scan_circle_pan == 0) {my.scan_circle_pan = 160;} 
   if(my.scan_circle_tilt == 0) {my.scan_circle_tilt = 140;} 
   if(my.scan_circle_lenght == 0) {my.scan_circle_lenght = 1500;} 
   if(my.jump_dist == 0) {my.jump_dist = 50;} 

   if(my.damage == 0) {my.damage = 20;} 
   my.enable_scan = on; 
   my.enable_detect = on; 
   my.enable_impact = on; 
   my.event = NiverAI_event; 
   var last_known_target[3]; 
   var fire_pause; 
   var may_trace;   // for saving fps 
   var jump_pause; 
   while(my.health > 0) 
   { 
      my.jump_pause = clamp(my.jump_pause-1*time,0,my.jump_pause); 
       
      if(my.enemy == 0) 
      { 
         temp.pan = my.scan_circle_pan; 
         temp.tilt = my.scan_circle_tilt; 
         temp.z = my.scan_circle_lenght; 
         my.scan_mode = scan_Search; 
         scan_entity(my.x,temp); 
      } 
      else 
      { 
         you = ptr_for_handle(my.enemy); 
         if(you == null) {my.enemy=0;goto(no_target);} 
         if(you.health <= 0) {my.enemy=0;goto(no_target);} 
         if(you.team == my.team) {my.enemy = 0;goto(no_target);} 
         you = ptr_for_handle(my.enemy); 
         if(vec_dist(you.x,my.x) < my.range) 
         { 
            result = c_trace(my.x,you.x,ignore_passable+use_box+ignore_models+ignore_me+ignore_you); 
            you = ptr_for_handle(my.enemy); 
            if(result > vec_dist(my.x,you.x)-5) 
            { 
               if(my.speed_z < 1) 
               { 
                  vec_set(my.target_x,nullvector); 
                  if(fire_pause < 1) 
                  { 
                     vec_set(temp,you.x); 
                     vec_sub(temp,my.x); 
                     vec_to_angle(my.pan,temp); 
                     my.AI_tilt = my.tilt; 
                     my.tilt = 0; 
                     fire_pause = NiverAI_attack(); 
                     my.skill46 = 0; 
                     while(my.skill46 < 99) 
                     { 
                        c_move(my,nullvector,vector(0,0,my.speed_z*time),ignore_passable); 
                        ent_animate(my,attack_anim,my.skill46,ANM_CYCLE); 
                        my.skill46 += 3*time; 
                        wait(1); 
                     } 
                  } 
               } 
               you = ptr_for_handle(my.enemy); 
               vec_set(last_known_target,you.x); 
            } 
//            else 
//            { 
//               vec_set(my.target_x,last_known_target); 
//               my.speed_x = 15; 
//            } 
         } 
         no_target: 
      } 
      fire_pause = clamp(fire_pause-1*time,0,fire_pause); 
       
      if(may_trace < 0.5) 
      { 
         may_trace = random(1)+1; 
          
         vec_set(temp,vector(my.x,my.y,my.z-30)); 
         result = c_trace(my.x,temp,ignore_models+ignore_me+ignore_you+use_box); 
         if(result > vec_dist(my.x,temp)-2) 
         { 
            my.speed_z = clamp(my.speed_z-3*time,-12,my.speed_z); 
         } 
         else 
         { 
            my.speed_z = 0; 
         } 
      } 
      may_trace = clamp(may_trace-0.75,0,may_trace); 
       
      if(my.target_x != nullvector) 
      { 
//////////////////////////////////////////commented to keep models from moving out of position///
//         if(vec_dist(vector(my.target_x,my.target_y,my.z),my.x) > 40) 
//         { 
//            vec_set(temp,my.target_x); 
//            vec_sub(temp,my.x); 
//            vec_to_angle(my.pan,temp); 
//            my.tilt = 0; 
//            c_move(my,vector(my.speed_x*time,my.speed_y*time,0),vector(0,0,my.speed_z*time),ignore_passable+ignore_models+glide); 
//            if(my.speed_x > 9){ent_animate(my,run_anim,my.skill46,ANM_CYCLE);} 
//            else {ent_animate(my,walk_anim,my.skill46,ANM_CYCLE);} 
//            my.skill46 += 5*time; 
//         } 
//         else 
//         { 
//            vec_set(my.target_x,nullvector); 
//         } 
//      } 
//      else 
//      { 
/////////////////////////////////////////////////////////////////////////////////////////////////
         ent_animate(my,stand_anim,my.skill46,ANM_CYCLE); 
         ent_animate(my,alt_stand_anim,my.skill46,ANM_CYCLE); 
         my.skill46 += 2*time; 
      } 
      my.skill46 %= 100; 
      wait(1); 
   } 
   my.skill46 = 0; 
//   while(my.skill46 < 99) 
//   { 
//      ent_animate(my,death_anim,my.skill46,ANM_CYCLE); 
//      my.skill46 += 5*time; 
//      wait(1); 
//   } 
 ///////////////////////////commented to keep models from dying////////////////////////
//   sleep(2); 
//   my.transparent = on; 
//   while(my.alpha > 0) 
//   { 
//      my.alpha -= 10*time; 
//      wait(1); 
//   } 
//   remove me; 
////////////////////////////////////////////////////////////////////////////////////////
} 
/////////////////////////////////////////////////////////// 
// title: Niver AI by Claus N. 
// section: _ 
// section: Basics 
// desc: Health defines the amount of health for the AI. 
// desc: Fire_mode is how they shoot, here's a few examples: 
// desc: 3 = machin gun 
// desc: 21 = shotgun 
// desc: 12 = rocket launcher 
// desc: The AI's attack everything which has enable_scan, 
// desc: and not the same team. 
// desc: Damage is how much their shots damage. 
// use: health,fire_mode,team,damage 
// section: _ 
// section: Detection 
// desc: Scan_circle_pan and tilt are the pan and tilt 
// desc: values of the "scanning circle" used in 
// desc: scan_entity. scan_circle_lenght is the 
// desc: lenght/width of scan_enity. 
// desc: Tip: You should use a range and scan_circle_lenght 
// desc: of at least 1000. 
// use: range, scan_circle_pan, scan_circle_tilt, scan_circle_lenght, 
// section: _ 
// section: Advanced 
// desc: With target_x, y and z, you can set walkpoint 
// desc: coordinates from start. 
// section: _ 
// section: the skills: 
// use: target_x, target_y, target_z 
action soldat_fight  //Basic_Niver 
{ 
   Niver_AI(); 
   
} 


///////////////////////////////////////////////////////////
