// Template file v5.15r (12/18/01)
////////////////////////////////////////////////////////////////////////
// File: weapons.wdl

IFNDEF WEAPON_DEFS;
SOUND bang_bolt,<bangclik.wav>;
sound empty_wav = <gunjam.wav>;
SOUND gun_click,<empty.wav>;
SOUND gun_wham,<playershot.wav>;
sound rifle_shot = <rifleshot.wav>;
SOUND explo_wham,<explo.wav>;
DEFINE hit_wham,explo_wham;
SOUND gun_fetch,<beamer.wav>;
DEFINE ammo_fetch,gun_fetch;
DEFINE health_fetch,gun_fetch;
DEFINE muzzle_flash,<part_old.pcx>;
DEFINE small_flash,<particle.pcx>;
DEFINE EXPLO_FRAMES,7;
DEFINE WEAPON_AMPL,0.2; // swaying
ENDIF;
IFNDEF WEAPON_DEFS2;
DEFINE bullethole_map,<ibulhole.pcx>;    // bullet hole bitmap ***
DEFINE ibullethole_map,<ibulhole.pcx>;    // inverted bullet hole bitmap (white) ***
ENDIF;
define test_gun1,1;
define _leave_a_gun, skill47;

var ammo1[3] = 0, 0, 0;
var ammo2[3] = 0, 0, 144;
var ammo3[3] = 450, 0, 450;

// dynamic light values
var light_explo[3]  =  50,  50, 255;// 

var light_flash[3]  = 200, 150,  50;// 

var light_muzzle[3] = 200,  20,  20;// 

var light_bullet[3] = 200,  50,  20;// 

//// you'll probably want to redefine those strings. No problem.
STRING got_ammo1_str,"";
STRING got_ammo2_str,"";
STRING got_ammo3_str,"";

STRING got_medi_str,"";
STRING got_gun1_str,"";
STRING got_gun2_str,"";
STRING got_gun3_str,"";

DEFINE __REPEAT,FLAG7;
// Define SKILLs
DEFINE _OFFS_X,SKILL1;
DEFINE _OFFS_Y,SKILL2;
DEFINE _OFFS_Z,SKILL3;
DEFINE _AMMOTYPE,SKILL4;
DEFINE _BULLETSPEED,SKILL5;
DEFINE _WEAPONNUMBER,SKILL6;
DEFINE _FIRETIME,SKILL7;
//SKILL8 = _FIREMODE from movement.wdl
DEFINE _GUN_SOURCE_X,SKILL11;
DEFINE _GUN_SOURCE_Y,SKILL12;
DEFINE _GUN_SOURCE_Z,SKILL13;
DEFINE _OFFS_FLASH,SKILL14;
DEFINE _RECOIL,SKILL15;
DEFINE _DAMAGE,SKILL16;
DEFINE _DISPLACEMENT,SKILL17;
DEFINE _FIRE,SKILL18;
DEFINE _PACKAMOUNT, SKILL5; // ammo/med pack ammo amounts
// Constants
DEFINE MODE_DAMAGE,3;
DEFINE DAMAGE_SHOOT,1;
DEFINE DAMAGE_IMPACT,2;
DEFINE DAMAGE_EXPLODE,3;
DEFINE MODE_FIRE,28;
DEFINE FIRE_PARTICLE,4;
DEFINE FIRE_DPARTICLE,8;
define fire_Mparticle,16;
DEFINE FIRE_BALL,12;
DEFINE FIRE_ROCKET,16;
DEFINE FIRE_LASER,20;
DEFINE BULLET_SMOKETRAIL,32;
DEFINE MODE_HIT,384;
DEFINE HIT_FLASH,128;
DEFINE HIT_EXPLO,256;
DEFINE HIT_GIB,384;
DEFINE HIT_SMOKE, 512;
DEFINE HIT_SCATTER,1024;
DEFINE GUNFX_BRASS,2048;  // gun drops brass
DEFINE HIT_SPARKS,8192;
DEFINE HIT_HOLE 16384;
DEFINE GUNFX_ANIMATE, 32768;  // gun has a firing animation
///////////////////////////////////////////////////////////////////////
entity* weapon;

entity* weapon1;
entity* weapon2;
entity* weapon3;

entity* weaponTmpSyn;     // tmp ENTITY pointer
var weapon_1 = 0;  // set to 1 if the player owns that weapon
var weapon_2 = 0;
var weapon_3 = 0;

var gun_muzzle[3];
var gun_source[4]; // trace start point   (gun_source[3] = 9 if used)
var gun_target[3];
var gun_loaded = 1;
var fireball_speed = 0;
var weapon_number = 0;
var ammo_number = 0;
var range = 0;
var damage = 0;
var fire_mode = 0;
var weapon_firing = 0;

action ammo_type1
  {
//  MY.__ROTATE = OFF;
  MY._AMMOTYPE = 1;
  MY._PACKAMOUNT = 6;
  ammopac();
  }
// uses _PACKAMOUNT
// uses __SILENT
action ammo_type2
  {
//  MY.__ROTATE = OFF;
  MY._AMMOTYPE = 2;
  MY._PACKAMOUNT = 12;
  ammopac();
  }
// uses _PACKAMOUNT
// uses __SILENT
action ammo_type3
  {
//  MY.__ROTATE = OFF;
  MY._AMMOTYPE = 3;
  MY._PACKAMOUNT =450;
  ammopac();
  }

function rifle_smoke()
{

if(MY_AGE == 0)
  {
  MY_SPEED.X = random(1)-0.5; // -0.5 to +0.5
  MY_SPEED.Y = random( -3.506 ) - -1.753 ;//random(1)-1;     // -1 to +1
  MY_SPEED.Z = random( 1.709 );//random(1)+0.3;     // +1 to +2
  MY_SIZE = 0.1;//random(1)+1; // 25 to 50 in size
  MY_FLARE = ON;
  MY_COLOR.RED = 150;//245;
  MY_COLOR.GREEN = 150;//200;
  MY_COLOR.BLUE = 150;//80;
	MY_TRANSPARENT = ON;
	MY_ALPHA = 10;
  return;
  }
//// increase the size of the smoke particle (up to max)
if(MY_SIZE < 800)
  {
  MY_SIZE += (120 - MY_SIZE)*0.1*TIME;
  }
// Remove old particles
if(MY_AGE >= 4)
  {
  MY_ACTION = particle_fadeout;//NULL;
  }
}

function weapon_carry()
  {
  if(weapon == NULL || player == NULL) 
    {
     return; 
    }
  if(person_3rd != 0)
    {
    weapon.INVISIBLE = ON;
    player._FIREMODE = weapon._FIRE;  //show the attack animation for the player

    }
  else
    {
    weapon.INVISIBLE = OFF;
    MY_POS.X = weapon.SKILL1;
    MY_POS.Y = -weapon.SKILL2;
    MY_POS.Z = -weapon.SKILL3;
    if(weapon._RECOIL > 0)
      {
      MY_POS.X -= weapon._DISPLACEMENT;
      }
    if(player.__BOB == ON)
      {
      MY_POS.Y += headwave * WEAPON_AMPL;
      MY_POS.X += headwave * WEAPON_AMPL;
      MY_POS.Z -= headwave * WEAPON_AMPL;
      }
    _set_pos_ahead_xyz();
    weapon.X = MY_POS.X ;
    weapon.Y = MY_POS.Y;
    weapon.Z = MY_POS.Z;
    weapon.PAN = CAMERA.PAN;
    weapon.TILT = CAMERA.TILT;
    if(weapon._RECOIL < 0)
      {
      weapon.TILT -= weapon._DISPLACEMENT;
      }
    }
  }
////////////////////////////////////////////////////////////////////////
// Gun select functions
ACTION _gun_select1 
  {
   weapon_number = 1; gun_select(); 
  }
ACTION _gun_select2 
  {
   weapon_number = 2; gun_select(); 
  }
ACTION _gun_select3 
  {
   weapon_number = 3; gun_select(); 
  }

function gun_select()
  {
  if(weapon != NULL)
    {
     // remove old weapon
    weapon.INVISIBLE = ON;
    weapon.PASSABLE = ON;
    }
  if(weapon_number == 1) 
    {
     stop_me(); //allows the player to walk with pistol
      ME = weapon1;
    }
  if(weapon_number == 2) 
    {
     start_me(); //allows the player to walk with rifle
      ME = weapon2; 
    }
  if(weapon_number == 3) 
    {
    stop_me(); //stops the player from walking with heavy machine gun
      ME = weapon3;
          }

  ammo_number = MY._AMMOTYPE;
  MY.INVISIBLE =  OFF;
  MY.PASSABLE = ON; // prevent collision with obstacles
  MY.NEAR = ON; // prevent clipping
  weapon = ME;  // I'm the current weapon now
  carry = weapon_carry;
  EXCLUSIVE_GLOBAL;
  // handle firing
  while(weapon == ME)
    {
    if(weapon_firing && (gun_loaded > 0) && (MY._FIRE <= 0) )
      {
      gun_fire();
      }
    if((weapon_firing == 0) && (gun_loaded == 0) && (MY.__REPEAT == OFF))
      {
      gun_loaded = 1;
      }
    wait(1);
    }
  return(weapon_number);
  }

function _ammo_limit()
  {
  if(ammo1 > ammo1.Z) 
    {
     ammo1 = ammo1.Z; 
    }
  if(ammo2 > ammo2.Z) 
    {
     ammo2 = ammo2.Z; 
    }
  if(ammo3 > ammo3.Z) 
    {
     ammo3 = ammo3.Z; 
    }
}
function gun_pickup()
  {
  if(EVENT_TYPE == EVENT_SCAN && indicator != _HANDLE) 
    {
     return; 
    }
  if(EVENT_TYPE == EVENT_PUSH && YOU != player) 
    {
     return; 
    }
  MY.ENABLE_SCAN = OFF;
  MY.ENABLE_CLICK = OFF;
  MY.ENABLE_PUSH = OFF;
  if(INT(MY._AMMOTYPE) == 1) 
    {
     ammo1 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5);
    }
  if(INT(MY._AMMOTYPE) == 2) 
    {
     ammo2 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5); 
    }
  if(INT(MY._AMMOTYPE) == 3) 
    {
     ammo3 += INT(FRC(MY._AMMOTYPE) * 1000 + 0.5);
    }

  MY._AMMOTYPE = INT(MY._AMMOTYPE); // ammo type
  _ammo_limit();
  weapon_number = MY._WEAPONNUMBER;
  if(weapon_number == 1) 
    {
    weapon1 = ME; weapon_1 = 1;  ON_1 = _gun_select1;  msg.STRING = got_gun1_str;
    }
  if(weapon_number == 2) 
    {
      weapon2 = ME; weapon_2 = 1;  ON_2 = _gun_select2;  msg.STRING = got_gun2_str; 
    }
  if(weapon_number == 3) 
    {
      weapon3 = ME; weapon_3 = 1;  ON_3 = _gun_select3;  msg.STRING = got_gun3_str; 
    }

//  if(MY.__SILENT != ON) 
//    {
//     show_message(); 
//    }
  gun_select();
  }

function ammo_pickup()
  {
  if(EVENT_TYPE == EVENT_SCAN && indicator != _HANDLE) 
    {
     return; 
    }
  if(EVENT_TYPE == EVENT_PUSH && YOU != player) 
    {
     return; 
    }
  if(MY._AMMOTYPE == 1) 
    {
     ammo1 += MY._PACKAMOUNT;  msg.STRING = got_ammo1_str; 
    }
  if(MY._AMMOTYPE == 2) 
    {
     ammo2 += MY._PACKAMOUNT;  msg.STRING = got_ammo2_str; 
    }
  if(MY._AMMOTYPE == 3) 
    {
     ammo3 += MY._PACKAMOUNT;  msg.STRING = got_ammo3_str; 
    }

  _ammo_limit();
  PLAY_SOUND ammo_fetch,50;
//  if(MY.__SILENT != ON)
//    {
//    // hide item..
//    MY.EVENT = NULL;
//    MY.PASSABLE = ON;
//    MY.INVISIBLE = ON;
//    waitt(MSG_TICKS); // wait for message to vanish
//    }
  remove(ME);
  }

ACTION ammopac
  {
  // default ammo type is 1
  if(MY._AMMOTYPE == 0) 
    {
     MY._AMMOTYPE = 1; 
    }
  // default ammo amount is a quarter of ammo maximum
  if(MY._PACKAMOUNT == 0)
    {
    if(MY._AMMOTYPE == 1) 
      {
       MY._PACKAMOUNT = ammo1.Z * 0.25; 
      }
    if(MY._AMMOTYPE == 2) 
      {
       MY._PACKAMOUNT = ammo2.Z * 0.25; 
      }
    if(MY._AMMOTYPE == 3) 
      {
       MY._PACKAMOUNT = ammo3.Z * 0.100;
      }

    }
  MY.EVENT = ammo_pickup;
  item_pickup();
  }
// Desc: handle medipac event
function medi_pickup()
  {
  if(EVENT_TYPE == EVENT_SCAN && indicator != _HANDLE) 
    {
     return; 
    }
  if(EVENT_TYPE == EVENT_PUSH && YOU != player) 
    {
     return; 
    }
  if(YOU == NULL) 
    {
      YOU = player; 
    }
  if(YOU == NULL) 
    {
     return; 
    }
  YOUR._HEALTH += MY.SKILL5;
  if(YOUR._HEALTH > 100) 
    {
     YOUR._HEALTH = 100; 
    }
    // health max at 100%
//  PLAY_SOUND health_fetch,50;
	media_play("klick.wav",null,100);
//  msg.STRING = got_medi_str;
//  if(MY.__SILENT != ON) 
//    {
//     show_message(); 
//    }
  remove(ME);
  }
// Desc: medipac entity
//
// uses _PACKAMOUNT
// uses __ROTATE, __SILENT

ACTION medipac
  {
//  MY.__SILENT = ON;
  if(MY._PACKAMOUNT == 0) 
    {
     MY._PACKAMOUNT = 100; 
    }
     
  MY.EVENT = medi_pickup;
  
  item_pickup();
  
  }
 
  
  
// Desc: restore a gun already owned by the player (from a previous level)
//
// Note: keep the gun in the level
function gun_restore()
  {
  // weapon was already picked up by the player
  MY._AMMOTYPE = INT(MY._AMMOTYPE); // happens on pickup
  MY.INVISIBLE = ON;
  MY.PASSABLE = ON;
  MY.ENABLE_SCAN = OFF;
  MY.ENABLE_CLICK = OFF;
  MY.ENABLE_PUSH = OFF;
  MY.EVENT = NULL;
  // Was it the last weapon the player carried?
  if(weapon_number == MY._WEAPONNUMBER)
    {
     gun_select(); 
    }
  }

ACTION gun
  {
  // set the weapon camera offset (if one is not already defined)
  if(MY._OFFS_X == 0)
    {
    MY._OFFS_X = 50;
    MY._OFFS_Y = 20;
    MY._OFFS_Z = 20;
    }
  if(MY._OFFS_FLASH == 0)
    {
    MY._OFFS_FLASH = MY.MAX_X + 10;  // Muzzle flash offset
    }
  // set the weapon source offset (if one is not already defined)
  if(MY._GUN_SOURCE_X == 0)
    {
    MY._GUN_SOURCE_X = MY._OFFS_X + MY._OFFS_FLASH;
    MY._GUN_SOURCE_Y = -MY._OFFS_Y;
    MY._GUN_SOURCE_Z = -MY._OFFS_Z;
    }
  // make sure we have a valid _WEAPONNUMBER
  if(MY._WEAPONNUMBER <= 0 || MY._WEAPONNUMBER > 7)
    {
     MY._WEAPONNUMBER = 1; 
    }
  // set damage
  MY._DAMAGE = FRC(MY._FIREMODE) * 100;
  if(MY._DAMAGE == 0)
    {
     MY._DAMAGE = 20; 
    }
   // default to 20 damage
  // set firemode
  MY._FIREMODE = INT(MY._FIREMODE);
  if(MY._FIREMODE == 0)
    {
     MY._FIREMODE = DAMAGE_SHOOT+FIRE_PARTICLE+HIT_FLASH; 
    }
     // default to
  // set recoil (up or back)
  MY._RECOIL = FRC(MY._BULLETSPEED) * 100;
  // set bullet speed
  MY._BULLETSPEED = ABS(MY._BULLETSPEED);
  if(MY._BULLETSPEED < 1)
    {
     MY._BULLETSPEED = 200; 
    }
     // default to 200
  // make sure we have an ammotype
  if(MY._AMMOTYPE == 0)
    {
     MY._AMMOTYPE = 1; 
    }
   // default ammotype
  MY.EVENT = gun_pickup;
  item_pickup();
  // check whether this gun was picked up before in another level,
  // and has to be re-created for this level
  if(MY._WEAPONNUMBER == 1 && weapon_1 == 1 && weapon1 == NULL)
    {
     weapon1 = ME; gun_restore();  return;
    }
  if(MY._WEAPONNUMBER == 2 && weapon_2 == 1 && weapon2 == NULL)
    {
     weapon2 = ME; gun_restore(); return; 
    }
  if(MY._WEAPONNUMBER == 3 && weapon_3 == 1 && weapon3 == NULL)
    {
     weapon3 = ME;
   //  gun_restore();
      return;
    }
 }

function gun_givePlayer()
  {
  gun();   // init the gun
  MY.ENABLE_SCAN = OFF;
  MY.ENABLE_CLICK = OFF;
  MY.ENABLE_PUSH = OFF;
  if(INT(MY._AMMOTYPE) == 1) 
    {
     ammo1 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5); 
    }
  if(INT(MY._AMMOTYPE) == 2) 
    {
     ammo2 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5); 
    }
  if(INT(MY._AMMOTYPE) == 3) 
    {
     ammo3 += INT(FRC(MY._AMMOTYPE) * 100 + 0.5); 
    }

  MY._AMMOTYPE = INT(MY._AMMOTYPE); // ammo type
  _ammo_limit();
  weapon_number = MY._WEAPONNUMBER;
  if(weapon_number == 1) 
    {
      weapon1 = ME; weapon_1 = 1;  ON_1 = _gun_select1;  msg.STRING = got_gun1_str; 
    }
  if(weapon_number == 2) 
    {
      weapon2 = ME; weapon_2 = 1;  ON_2 = _gun_select2;  msg.STRING = got_gun2_str; 
    }
  if(weapon_number == 3) 
    {
      weapon3 = ME; weapon_3 = 1;  ON_3 = _gun_select3;  msg.STRING = got_gun3_str; 
    }

  gun_select();
  }
//////////////////////////////////////////////////////////////////////
// Desc: fire weapon
function weapon_fire()
{
	weapon_firing = 1;
 	while(MOUSE_LEFT) { wait(1); }
	weapon_firing = 0;
}



// Desc: deselect weapon
function weapon_remove()
  {
  if(weapon != NULL)
    {
    weapon.INVISIBLE = ON;
    weapon = NULL;
    weapon_number = 0;
    }
  }
// Desc: put weapons and ammo to inital state
//
function weapon_init()
  {
  weapon_remove();
  ammo1 = 0;
  ammo2 = 0;
  ammo3 = 0;

  weapon_1 = 0;
  weapon_2 = 0;
  weapon_3 = 0;

  }
//////////////////////////////////////////////////////////////////////
string anim_gun_shot = "shot";  // gun animation string

function gun_animate()
  {
  while(MY._FIRE > 0)
    {
    // play one cycle
    temp = ((MY._FIRETIME - MY._FIRE)/ MY._FIRETIME) * 100;
    ent_cycle(anim_gun_shot,temp);
    wait(1);
    }
  ent_frame(anim_gun_shot,0);  // return to base frame
  }


function gun_fire()
  {
  
  if(MY._AMMOTYPE == 1)
    {
    if(ammo1 > 0) 
      {
       ammo1 -= 1; 
      }
    else
      {
       _gun_fire_no_ammo(); return; 
      }
    }
  if(MY._AMMOTYPE == 2)
    {
    if(ammo2 > 0) 
      {
       ammo2 -= 1; 
      }
    else
      {
       _gun_fire_no_ammo(); return; 
      }
    }
  if(MY._AMMOTYPE == 3)
    {
    if(ammo3 > 0) 
      {
       ammo3 -= 1; 
      }
    else
      {
       _gun_fire_no_ammo(); return; 
      }
    }

    else
      {
       _gun_fire_no_ammo(); return; 
      }
//    }
  gun_loaded = 0;
  // place muzzle flash
  if((person_3rd != 0) && (player != NULL))
    {
    MY_POS.X = player.MAX_X - player.MIN_X;
    MY_POS.Y = 0;
    MY_POS.Z = 0;
    vec_rotate(MY_POS,player.PAN);
    MY_POS.X += player.X;
    MY_POS.Y += player.Y;
    MY_POS.Z += player.Z;
    }
  else
    {
    MY_POS.X = MY.SKILL1 + MY._OFFS_FLASH;
    MY_POS.Y = -MY.SKILL2;
    MY_POS.Z = -MY.SKILL3;
    _set_pos_ahead_xyz();
    }
  vec_set(gun_muzzle.X,MY_POS.X);
//  create(muzzle_flash,gun_muzzle,_flashup);
  // calculate target
  MY_POS.X = MY._BULLETSPEED;
  if((person_3rd != 0) && (player != NULL))
    {
    MY_POS.Y = 0;
    MY_POS.Z = 0;
    vec_rotate(MY_POS,player.PAN);
    MY_POS.X += player.X;
    MY_POS.Y += player.Y;
    MY_POS.Z += player.Z;
    }
  else
    {
    MY_POS.Y = -MY.SKILL2;
    MY_POS.Z = -MY.SKILL3;
    _set_pos_ahead_xyz();
    }
  vec_set(gun_target.X,MY_POS.X);
  wait(1); // allow muzzle_flash to become passable (so bullet does not hit it!)
  // place gun trace source back (DCP fix 04/13/01)
  if((person_3rd != 0) && (player != NULL))
    {
    MY_POS.X = (player.MAX_X - player.MIN_X);
    MY_POS.Y = 0;
    MY_POS.Z = 0;
    vec_rotate(MY_POS,player.PAN);
    MY_POS.X += player.X;
    MY_POS.Y += player.Y;
    MY_POS.Z += player.Z;
    }
  else
    {
    MY_POS.X = MY._GUN_SOURCE_X;//?-(player.MAX_X - player.MIN_X)/2; //--MY.SKILL1 + MY._OFFS_FLASH;
    MY_POS.Y = MY._GUN_SOURCE_Y;//? -MY.SKILL2;
    MY_POS.Z = MY._GUN_SOURCE_Z;//?-MY.SKILL3;
    _set_pos_ahead_xyz();
    }
  vec_set(gun_source.X,MY_POS.X);
  gun_source[3] = 9;             // mark this as 'player fired'
  // emit a bullet or particle
  shot_speed.X = (gun_target.X - gun_source.X);
  shot_speed.Y = (gun_target.Y - gun_source.Y);
  shot_speed.Z = (gun_target.Z - gun_source.Z);
  damage = MY._DAMAGE;
  fire_mode = MY._FIREMODE;
  // if player is not already passable
  if(player.passable == OFF)
    {
    player.passable = ON;   // make it so the gun doesn't hit the player
    gun_shot();       // fire the shot
    player.passable = OFF;
    }
  else
    {
    gun_shot();
    }
  MY._FIRE = MY._FIRETIME;
  // animate gun?
  if((fire_mode & GUNFX_ANIMATE) != 0)
    {
    gun_animate(); // animate gun cycle
    }
  MY._DISPLACEMENT = MY._RECOIL;
  while(MY._FIRE > 0)
    {
    wait(1);
    // rock back into place from recoil
    MY._DISPLACEMENT *= 0.6;
    MY._FIRE -= TIME;
    }
  MY._DISPLACEMENT = 0 ;
  MY._FIRE = 0 ;
  if(MY.__REPEAT == ON) 
    {
     gun_loaded = 1;
    }
  }
  

function _gun_fire_no_ammo()
  {
  	
  	var clik_pause = 8;
  PLAY_ENTSOUND(ME,empty_wav,80);
  return(clik_pause);
  }

var _gun_shot_temp[3];     // 'local' temp vector
var _gun_shot_sCount;      // 'local' counter
var scatter_number = 6;    // number of SCATTER rounds
DEFINE SCATTER_RAND, 160;      // SCATTER width
DEFINE SCATTER_HALF_RAND, 80;
// Desc: select and handle shot type using 'fire_mode'
//
// needs gun_muzzle,shot_speed,damage,fire_mode
//
function gun_shot()
  {
  // select and handle shot type using 'fire_mode'
  // particle trail shot (line of particles)
  if((fire_mode & MODE_FIRE) == FIRE_PARTICLE)
    {
    vec_set(p,gun_muzzle);
    vec_set(p2,gun_target);
    particle_line();
    }

  //for machgun_fight action using machgun.wav
  if((fire_mode & MODE_FIRE) == FIRE_MPARTICLE)
    {
    vec_set(p,gun_muzzle);
    vec_set(p2,gun_target);
    particle_lineM();
    }
  // single particle
  if((fire_mode & MODE_FIRE) == FIRE_DPARTICLE)
    {
     emit(1,gun_muzzle,particle_shot); 
    }
  
//  if((fire_mode & GUNFX_BRASS) != 0)
//    {
//    emit(1,gun_muzzle,particle_gunBrass); // emit brass
//    }
  // bullet damage is done with a trace
  if((fire_mode & MODE_DAMAGE) == DAMAGE_SHOOT)
    {
    // set gun_target
    gun_target.X = 2*shot_speed.X + gun_muzzle.X;
    gun_target.Y = 2*shot_speed.Y + gun_muzzle.Y;
    gun_target.Z = 2*shot_speed.Z + gun_muzzle.Z;
    if((fire_mode & HIT_SCATTER) != 0) // scatter gun?
      {
      vec_set(_gun_shot_temp.X, gun_target.X); // save base gun_target
      _gun_shot_sCount = 0;
      while(_gun_shot_sCount < scatter_number)
        {
        // offset each shot by a random amount
        gun_target.X = _gun_shot_temp.X + (Random(SCATTER_RAND)-SCATTER_HALF_RAND);
        gun_target.Y = _gun_shot_temp.Y + (Random(SCATTER_RAND)-SCATTER_HALF_RAND);
        gun_target.Z = _gun_shot_temp.Z + (Random(SCATTER_RAND)-SCATTER_HALF_RAND);
        _gun_shot_damage_shoot();
        _gun_shot_sCount += 1;
        }
      vec_set(gun_target.X, _gun_shot_temp.X); // restore  gun_target
      }
    else
      {
      // fire one shot
      _gun_shot_damage_shoot();
      }
    }
  }

function _gun_shot_damage_shoot()
  {
  indicator = _GUNFIRE; // indicator for the entity that was hit
  trace_mode = IGNORE_ME + IGNORE_PASSABLE + ACTIVATE_SHOOT;
  if(gun_source[3] == 9)  // player firing?
    {
    // use gun_source
    //--CREATE(<ARROW.PCX>,gun_source,_test_arrow);   // used to test gun_source
    RESULT = trace(gun_source,gun_target);
    gun_source[3] = 0; // reset value
    }
  else
    {
    // use gun_muzzle
    //--CREATE(<ARROW.PCX>,gun_muzzle,_test_arrow);   // used to test gun_muzzle
    RESULT = trace(gun_muzzle,gun_target);
    }

  if(RESULT > 0)
    {
     // hit something?
    _hit_point_effect(); // send fire_mode and TARGET
    }
  }
///////////////////////////////////////////////////////////////////////
// Desc: hit flash
//
function _blowup()
  {
  MY.SCALE_X = 2;
  MY.SCALE_Y = 2;
  vec_scale(MY.SCALE_X,actor_scale);
  MY.PASSABLE = ON;
  MY.FACING = ON;
  MY.NEAR = ON;
  MY.FLARE = ON;
  MY.AMBIENT = 100;
  MY.LIGHTRED = light_flash.RED;
  MY.LIGHTGREEN = light_flash.GREEN;
  MY.LIGHTBLUE = light_flash.BLUE;
  MY.LIGHTRANGE = 64;
  wait(1);
  PLAY_ENTSOUND ME,hit_wham,300;
  remove(ME);
  }
// Desc: muzzle flash
//
function _flashup()
  {
  MY.SCALE_X = 2;
  MY.SCALE_Y = 2;
  vec_scale(MY.SCALE_X,actor_scale);
  MY.PASSABLE = ON;
   //Set flare only in D3D mode  ********************** problem??
  if(VIDEO_MODE > 8)
    {
     MY.FLARE = ON;
    }
  else
    {
     MY.TRANSPARENT = ON;
    }
  my.flare = on;
  MY.FACING = ON;
  MY.AMBIENT = 100;
  MY.LIGHTRED = light_muzzle.RED;
  MY.LIGHTGREEN = light_muzzle.GREEN;
  MY.LIGHTBLUE = light_muzzle.BLUE;
  MY.LIGHTRANGE = 100;
  wait(1);
  remove(ME);
  }
function _fireball_event()
  {
  // check for all collision events
  if(EVENT_TYPE == EVENT_BLOCK
  || EVENT_TYPE == EVENT_ENTITY
  || EVENT_TYPE == EVENT_STUCK
  || EVENT_TYPE == EVENT_IMPACT
  || EVENT_TYPE == EVENT_PUSH)
    {
    wait(1);// added to avoid Dangerous instruction
    EXCLUSIVE_ENTITY; // terminate other actions, to stop moving
    MY.EVENT = NULL;
    range = MY._DAMAGE * 3;
    damage = MY._DAMAGE;
    temp.PAN = 360;
    temp.TILT = 180;
    temp.Z = range;
    indicator = _EXPLODE; // must always be set before scanning
    scan(MY.POS,MY_ANGLE,temp);
    // morph BULLET_EXPLO,ME;
    MY._DIEFRAMES = EXPLO_FRAMES;
    actor_explode();
    }
  }

function bullet_shot()
  {
  vec_scale(MY.SCALE_X,actor_scale); // use actor_scale
  MY.ENABLE_BLOCK = ON;
  MY.ENABLE_ENTITY = ON;
  MY.ENABLE_STUCK = ON;
  MY.ENABLE_IMPACT = ON;
  MY.ENABLE_PUSH = ON;
  MY.EVENT = _fireball_event;
  MY.FACING = ON; // in case of fireball
  MY.LIGHTRED = light_bullet.RED;
  MY.LIGHTGREEN = light_bullet.GREEN;
  MY.LIGHTBLUE = light_bullet.BLUE;
  MY.LIGHTRANGE = 100;
  MY.AMBIENT = 100;
  MY.SKILL2 = shot_speed.x;
  MY.SKILL3 = shot_speed.y;
  MY.SKILL4 = shot_speed.z;
  MY._DAMAGE = damage;
  MY._FIREMODE = fire_mode;
  // my.near is set by the explosion
  while(MY.NEAR != ON)
    {
    wait(1); // wait at the loop beginning, to let it appear at the start position
    temp = TIME;
    if(temp > 1.5) 
      {
       temp = 1.5; 
      }
     // make bullet slower on slow PCs
    // MOVE moves by a distance, so multiply the speed by time.
    fireball_speed.x = MY.SKILL2 * temp;
    fireball_speed.y = MY.SKILL3 * temp;
    fireball_speed.z = MY.SKILL4 * temp;
    if((MY._FIREMODE & BULLET_SMOKETRAIL) == BULLET_SMOKETRAIL)
      {
      temp = 3 * TIME;
      if(temp > 6) 
        {
         temp = 6; 
        }
       // generate max 6 particels
      emit(temp,MY.POS,particle_fade);  // smoke trail
      }
    vec_scale(fireball_speed,movement_scale); // scale fireball_speed by movement_scale
    //--move(ME,nullskill,fireball_speed);
    move_mode = ignore_you + ignore_passable + activate_trigger;
    result = ent_move(nullskill,fireball_speed);
    }
  }

ACTION actor_explode
  {
  MY.FACING = ON; // face the camera
  MY.NEAR = ON;
  MY.FLARE = ON;
  MY.PASSABLE = ON; // don't push the player through walls
  MY.FRAME = 1;
  wait(1);
  PLAY_ENTSOUND ME,explo_wham,1000;
  MY.LIGHTRED = light_explo.RED;
  MY.LIGHTGREEN = light_explo.GREEN;
  MY.LIGHTBLUE = light_explo.BLUE;
  MY.AMBIENT = 100;
  MY.LIGHTRANGE += 50;
  // use the new sprite animation
  while(MY.FRAME < MY._DIEFRAMES)
    {
    wait(1);
    MY.LIGHTRANGE += 15;
    MY.LIGHTRED += 20 * TIME; // fade to red
    MY.LIGHTBLUE -= 20 * TIME;
    MY.FRAME += TIME;
    }
  wait(1);
  remove(ME);
  }
// Desc: create a hit point 'effect' depending on (fire_mode & MODE_HIT) value
//
// Input:fire_mode
//   TARGET
//
function _hit_point_effect()
  {
  // flash at hit point?
  if((fire_mode & MODE_HIT) == HIT_FLASH)
    {
    weaponTmpSyn = YOU;  // save YOU value
    create(small_flash,TARGET,_blowup);
    YOU = weaponTmpSyn;
    }
  // smoke at hit point?
  if(fire_mode & HIT_SMOKE)
    {
    emit(20,TARGET,particle_smoke); // emit smoke
    }
  if(fire_mode & HIT_SPARKS)
    {
    emit(20,TARGET,particle_scatter); // emit sparks
    }
  // bullet hole ***
  if(fire_mode & HIT_HOLE)
    {
    if(YOU == NULL) // hit wall (not entity)
      {
      create(bullethole_map,TARGET,bullet_hole);  // create bullet hole
      }
    }
  }
var bullet_hole_index = 0;
DEFINE kMaxBulletHole 100;
var h_bullet_hole_array[kMaxBulletHole];
entity* p_bullet_hole_temp;

function bullet_hole()
  {
  // check for maximum bullet holes at any time
  if(bullet_hole_index >= kMaxBulletHole)
    {
    bullet_hole_index = 0;
    }
  // check to see if its already in use
  temp = h_bullet_hole_array[bullet_hole_index];
  if(temp != 0)
    {
    // remove old hole
    p_bullet_hole_temp = ptr_for_handle(temp);
    remove(p_bullet_hole_temp);
    }
  // assign this as the new value in the array
  h_bullet_hole_array[bullet_hole_index] = handle(ME);
  MY.SKILL4 = bullet_hole_index;  // save index for removal
  bullet_hole_index += 1;  // increament index
  MY.TRANSPARENT = ON;
  MY.FLARE = ON;
  MY.PASSABLE = ON;
  MY.ORIENTED = ON;
  vec_to_angle(MY.PAN,NORMAL); // rotate to target normal
  waitt(160);          // time bullet stays before vanishing
  // alpha fade
  while(MY.ALPHA > 0)
    {
    MY.ALPHA -= TIME;
    waitt(1);
    }
  h_bullet_hole_array[MY.SKILL4] = 0; // zero out pointer
  remove(ME);
  }
// Desc: remove all bullet holes
// Note: Call this before changing levels.
function bullet_hole_remove_all()
  {
  bullet_hole_index = 0;
  while(bullet_hole_index < kMaxBulletHole)
    {
    temp = h_bullet_hole_array[bullet_hole_index];
    if(temp != 0)
      {
      // remove old hole
      p_bullet_hole_temp = ptr_for_handle(temp);
      remove(p_bullet_hole_temp);
      h_bullet_hole_array[bullet_hole_index] = 0; // zero out pointer
      }
    bullet_hole_index += 1;
    }
  }

BMAP cross_pcx , <cross.pcx>;
var cross_pos[2]=0,0;    /// =-15,7; // position of cross-hair on screen

PANEL cross_pan
  {
  bmap = cross_pcx; /// machine gun sight
  layer = 1;
  flags = overlay, transparent, refresh, d3d;
  }

// Desc: position the cross-hair panel at the center of the screen
//  and make it visible.
function pan_cross_show()
  {
  cross_pan.pos_x = (screen_size.x / 2) + cross_pos.x+10;
  cross_pan.pos_y = (screen_size.y / 2) + cross_pos.y-5;
  cross_pan.visible = ON;
  }

function pan_cross_hide()
  {
 cross_pan.visible = OFF;
  }

ON_MOUSE_LEFT weapon_fire;

ACTION leave_the_gun
  {
  MY.SKILL1 = 80; //set these values to fit the gun model
  MY.SKILL2 = 0;
  MY.SKILL3 = 17;
  my.x = your.x+20;
  my.y = your.y;
  my.z = your.z+1;
  MY.__REPEAT = ON;  // repeats (Auto-fire)
  MY.__BOB = ON;    // 'bobs' when the player moves
//  MY.__SILENT = ON;
  MY._WEAPONNUMBER = 3;     //4;
  MY._BULLETSPEED = 2000.10; 
  MY._FIRETIME = 1;
  MY._FIREMODE = DAMAGE_SHOOT + HIT_HOLE + fire_particle + HIT_FLASH + HIT_SMOKE + GUNFX_BRASS + GUNFX_ANIMATE + 0.20;
  MY._AMMOTYPE = 4.50;

//  SET MY.EVENT,gun;
//  SET MY.ENABLE_SCAN,ON;
  MY.TRIGGER_RANGE = 5;
  MY.enable_impact = on;

  /*
  WHILE (1)
    {
    MY.PAN += 5*TIME; //Use if you want the gun to rotate
    WAIT 1;
    }
    */
  }


///machine gun sound is in particle.wdl/////////////////////////////////************

action weap_mg_outpost
  {
//  MY.__ROTATE = OFF;  // gun rotates before being picked up
  MY.__REPEAT = ON;  // repeats (Auto-fire)
//  MY.__BOB = ON;    // 'bobs' when the player moves
//  MY.__SILENT = Off;
  MY.SKILL1 = 80;    // x,y,z pos of the gun
  MY.SKILL2 = 26;
  MY.SKILL3 = 17;
  MY._AMMOTYPE = 3.450;      // type of ammo '.' rounds in gun
  MY._WEAPONNUMBER =3;
  MY._BULLETSPEED = 1000.10;//800.10;  // bulletspeed '.' recoil
  MY._FIRETIME = 2.5;//1.75;
  MY._FIREMODE = DAMAGE_shoot + HIT_HOLE +fire_particle  + GUNFX_ANIMATE + 0.20;
  my.ambient = 55;
//  ent_vertex(my._gun_source_x,cross_pan.pos_y);
//  vec_sub(my._gun_source_x,my.x);
//  vec_set(my._gun_source_y,cross_pos.y);
  gun();
	gun_givePlayer();
	gun_jam();
	
	
}


